<template>
    <div>
        <div class="header">
            <div class="headerLabel md-subheading">{{$t('subtasks.header')}}</div>
            <div class="headerButton">
                <MdButton class="md-icon-button md-dense md-raised md-primary" @click="addSubTask()">
                    +
                </MdButton>
                <MdTooltip>{{$t('subtasks.addTooltip')}}</MdTooltip>
            </div>
        </div>
        <Table
                :paginate="5"
                :rows="$store.state.details.openTodo && $store.state.details.openTodo.subtasks"
                :row-key="(row) => row.name"
        >
            <template slot-scope="{row}">
                <TableColumn field="name" :label="$t('subtasks.nameColumHeader')" sort :row="row" />
                <TableColumn
                        :label="$t('subtasks.readyColumHeader')"
                        :row="row"
                        class="ready-col"
                >
                    <ReadyCheckbox :row="row" />
                </TableColumn>
            </template>
        </Table>
    </div>
</template>
<script>
  /* eslint-disable no-debugger */
  import Vue from 'vue';
  import Table from '../Table';
  import TableColumn from '../Table/TableColumn';
  import MdTooltip from '../TouchDeviceDisabledTooltip';
  import { MdCheckbox, MdButton } from 'vue-material/dist/components';
  import { prompt, alert } from '../modals';
  import i18n from '../../i18n';

  Vue.use(MdCheckbox);
  Vue.use(MdButton);

  const ReadyCheckbox = {
    template: `
        <MdCheckbox v-model="model" />
    `,
    props: {
      row: {
        type: Object,
        isRequired: true
      }
    },
    i18n,
    computed: {
      model: {
        get() {
          return this.$store.state.details.subtasksReady.indexOf(this.row.id) > -1;
        },
        set(value) {
          this.$store.dispatch(value ? 'ready' : 'unready', this.row.id);
        }
      }
    }
  };

  export default {
    name: 'todo-subtasks',
    components: {
      Table,
      TableColumn,
      ReadyCheckbox,
      MdTooltip
    },
    i18n,
    methods: {
      async addSubTask() {
        const message = this.$t('subtasks.newSubtaskPrompt');
        const subTaskName = await prompt(this,{ message });
        if (!subTaskName || !subTaskName.trim()) return;
        if (this.$store.state.details.openTodo.subtasks.find(({ name }) => name === subTaskName)) {
          const message = this.$t('subtasks.newSubtaskAleadyThere', { name: subTaskName });
          await alert(this, { message })
        } else {
          this.$store.dispatch('addSubTask', subTaskName);
        }
      }
    },
    computed: {
      subtasks() {
        return this.$store.state.details.openTodo.subtasks;
      }
    }
  }
</script>
<style scoped>
    .header {
        display: flex;
        margin-bottom: 10px;
    }

    .headerLabel {
        flex: 1000 1px;
    }

    .headerButton {
        flex: 1 20px;
    }
</style>
<style>
    .ready-col {
        width: 20px;
    }
</style>
